#property indicator_separate_window

#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_color3  DarkGray
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_width3  2

extern int    FastEma    = 12;
extern int    SlowEma    = 26;
extern int    Price      = PRICE_CLOSE;
extern double ObOsPeriod = 26;

double macd[];
double up[];
double dn[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,up);
   SetIndexBuffer(1,dn);
   SetIndexBuffer(2,macd);
   return(0); 
}

int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   double alpha = 2.0 / (1.0+ObOsPeriod);
   for(int i=limit; i>=0; i--)
   {
      macd[i] = iEma(iMA(NULL,0,1,0,MODE_SMA,Price,i),FastEma,i,0)-iEma(iMA(NULL,0,1,0,MODE_SMA,Price,i),SlowEma,i,1);
      if (macd[i]>0)
            up[i] = up[i+1] + alpha*(macd[i]-up[i+1]);
      else  up[i] = up[i+1];
      if (macd[i]<0)
            dn[i] = dn[i+1] + alpha*(macd[i]-dn[i+1]);
      else  dn[i] = dn[i+1];
            
   }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workEma[][2];
double iEma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars); r = Bars-r-1;

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+alpha*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}